%function run_nsb_countdata_allpos( dict_pos_fname, dict_pair_fname )
dict_pos_fname = 'protease_treated_17SEP2013.src.1998.blue.noheader.consensus_added_sample_0_dict_pos.txt';
dict_pair_fname = 'protease_treated_17SEP2013.src.1998.blue.noheader.consensus_added_sample_0_dict_pair.txt';

dpos = load(dict_pos_fname, '-ascii');
dpair = load(dict_pair_fname, '-ascii');

[mpos, npos] = size(dpos)
[mpair, npair] = size(dpair)
K_npos = 20; % 20 different states for every position
K_npair = 400; % 400 possible pairs of 20 amino acids

hpos = zeros(1, mpos); % mpos: sequence length
hpair = zeros(mpos, mpos);
hpos_sd = zeros(1, mpos); % mpos: sequence length
hpair_sd = zeros(mpos, mpos);
mi = zeros(mpos, mpos);


for i=1:mpos
    nx_pos = dpos(i, 2:end); % 1st column is position number
    nx_pos( nx_pos == 0 ) = []; % remove zero counts, as nsb does not like that
    [n, nx_size] = size(nx_pos);
    kx_pos = ones(1, nx_size);
    [s_nsb, ds_nsb, s_cl, ds_cl, xi_cl, s_ml, errc] = find_nsb_entropy( kx_pos, nx_pos, K_npos, 0.00001, 1);
    hpos(dpos(i, 1)+1) = s_nsb; % +1 for indexing positions from 1, thats how matlab does it
    hpos_sd(dpos(i, 1)+1) = ds_nsb; % +1 for indexing positions from 1, thats how matlab does it
end

for i=1:mpair
    nx_pair = dpair(i, 3:end); % 1st two columns are position number
    nx_pair( nx_pair == 0 ) = []; % remove zero counts, as nsb does not like that
    [n, nx_size] = size(nx_pair);
    kx_pair = ones(1, nx_size);
    [s_nsb, ds_nsb, s_cl, ds_cl, xi_cl, s_ml, errc] = find_nsb_entropy( kx_pair, nx_pair, K_npair, 0.00001, 1);
    hpair(dpair(i, 1)+1, dpair(i, 2)+1) = s_nsb;   % indexing positions from 1
    hpair_sd(dpair(i, 1)+1, dpair(i, 2)+1) = ds_nsb;   % indexing positions from 1
    mi(dpair(i, 1)+1, dpair(i, 2)+1) = hpos(dpair(i, 1)+1) + hpos(dpair(i, 2)+1) - hpair(dpair(i, 1)+1, dpair(i, 2)+1);
end
    
% write to files
dlmwrite(strcat(dict_pos_fname,'_NSB_hpos.txt'), hpos, ' '); % values in each rw separated by space
dlmwrite(strcat(dict_pos_fname,'_NSB_hpair.txt'), hpair, ' ');
dlmwrite(strcat(dict_pos_fname,'_NSB_hpos_sd.txt'), hpos_sd, ' '); % values in each rw separated by space
dlmwrite(strcat(dict_pos_fname,'_NSB_hpair_sd.txt'), hpair_sd, ' ');
dlmwrite(strcat(dict_pos_fname,'_NSB_mi.txt'), mi, ' ');

exit;

